# ==================================================================
# Plugins::MyLinks_SQL - Auto Generated Install Module
#
#   Plugins::MyLinks_SQL
#   Author  : Paul Wilson
#   Version : 0.0.2
#   Updated : Sun Dec  2 17:42:51 2001
#
# ==================================================================
#

package Plugins::MyLinks_SQL;
# ==================================================================
    use strict;
    use vars  qw/$VERSION $DEBUG $NAME $META/;
    use GT::Base;
    use GT::Plugins qw/STOP CONTINUE/;
    use Links qw/$CFG $IN $DB/;

    $VERSION = '0.0.2';
    $DEBUG   = 0;
    $NAME    = 'MyLinks_SQL';
# Inhert from base class for debug and error methods
    @Plugins::MyLinks_SQL::ISA = qw(GT::Base);

    $META = {
    'prog_ver' => 'Links SQL 2.0.5+',
    'description' => 'Ah the infamous MyLinks :)
This plugin will allow your users to track their favorite links. It supports page spanning and other goodies.',
    'license' => 'Freeware',
    'url' => 'http://www.wiredon.net/',
    'author' => 'Paul Wilson',
    'version' => '0.0.2'
};


sub pre_install {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they install
# the plugin.
#
    my $inst_msg = 'Install MyLinks SQL Cookie version by pressing the button below.';

    return $inst_msg;
}

sub pre_uninstall {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they remove the
# plugin.
#
    my $uninst_msg = 'Uninstall MyLinks SQL Cookie version by pressing the button below.';

    return $uninst_msg;
}

sub install {
# -------------------------------------------------------------------
# This function does the actual installation. It's first argument is
# a plugin manager which you can use to register hooks, install files,
# add menu options, etc. The second argument is a GT::Tar object which
# you can use to access any files in your plugin module.
#
# You should return an HTML formatted string that will be displayed 
# to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::MyLinks_SQL::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_menu ( 'MyLinks_SQL', [ ['How To', 'admin.cgi?do=plugin&plugin=MyLinks_SQL&func=howto'] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Max Per User', '25', 'Entering a value here will limit the number of favorites a user can save. ', 'TEXT', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Duplicate Error', 'You already have this link in your favorites list therefore cannot re-save it!', 'The error message displayed when someone tries to save an already saved link.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Empty Error', 'You can not delete all your links as you are not currently tracking any favorites!', 'The error displayed when someone tries to delete no existant links.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['No Such Link', 'Cannot save this link as there is no such record in the database!', 'Error displayed when someone tried to save a non-existant link.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Save Max', 'Sorry you have used up your saving limit!', 'Error displayed when the max favorites limit is reached.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Delete Non-Existant', 'You cannot delete this link as it doesn\'t exists in your favorites list!', 'Error displayed when someone tries to delete a link not in their list.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Cookie Name', 'gtlsql_fave', 'Enter the name of your MyLinks cookie. Please leave as is unless you need to change it.', 'TEXT', []
, []
, '' ] ] );
    $mgr->install_options ( 'MyLinks_SQL', [ ['Max Per Page', '5', 'Set the number of favorites to display per page. ', 'TEXT', []
, []
, '' ] ] );

# Silence warnings
    $GT::Tar::error ||= '';

# The following section will unarchive attached files into the 
# proper location.
    my $file;

# Copying Favorites.pm to $CFG->{admin_root_path} directory.
    $file = $tar->get_file ('Favorites.pm');
    $file->name("$CFG->{admin_root_path}/Links/User/Favorites.pm");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/Favorites.pm' ($GT::Tar::error)", 'WARN');

# Copying fave_link.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_link.html directory.
    $file = $tar->get_file ('fave_link.html');
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_link.html");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_link.html' ($GT::Tar::error)", 'WARN');

# Copying fave_added.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_added.html directory.
    $file = $tar->get_file ('fave_added.html');
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_added.html");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_added.html' ($GT::Tar::error)", 'WARN');

# Copying fave_deleted.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_deleted.html directory.
    $file = $tar->get_file ('fave_deleted.html');
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_deleted.html");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_deleted.html' ($GT::Tar::error)", 'WARN');

# Copying fave_deleted_all.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_deleted_all.html directory.
    $file = $tar->get_file ('fave_deleted_all.html');
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_deleted_all.html");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_deleted_all.html' ($GT::Tar::error)", 'WARN');

# Copying fave_error.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_error.html directory.
    $file = $tar->get_file ('fave_error.html');
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_error.html");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_error.html' ($GT::Tar::error)", 'WARN');

# Copying fave_main.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_main.html directory.
    $file = $tar->get_file ('fave_main.html');
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_main.html");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/fave_main.html' ($GT::Tar::error)", 'WARN');

# Copying fave.cgi to $CFG->{admin_root_path}/.. directory.
    $file = $tar->get_file ('fave.cgi');
    $file->name("$CFG->{admin_root_path}/../fave.cgi");
    $file->write or return MyLinks_SQL->error("Unable to extract file: '$CFG->{admin_root_path}/../fave.cgi' ($GT::Tar::error)", 'WARN');
    ;
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -------------------------------------------------------------------
# This function removes the plugin. It's first argument is
# also a plugin manager which you can use to register hooks, install files,
# add menu options, etc. You should return an HTML formatted string
# that will be displayed to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::MyLinks_SQL::error
#
    my $mgr = shift;
    
    $mgr->uninstall_menu ( 'MyLinks_SQL', [ ['How To', 'admin.cgi?do=plugin&plugin=MyLinks_SQL&func=howto'] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Max Per User', '25', 'Entering a value here will limit the number of favorites a user can save. ', 'TEXT', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Duplicate Error', 'You already have this link in your favorites list therefore cannot re-save it!', 'The error message displayed when someone tries to save an already saved link.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Empty Error', 'You can not delete all your links as you are not currently tracking any favorites!', 'The error displayed when someone tries to delete no existant links.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['No Such Link', 'Cannot save this link as there is no such record in the database!', 'Error displayed when someone tried to save a non-existant link.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Save Max', 'Sorry you have used up your saving limit!', 'Error displayed when the max favorites limit is reached.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Delete Non-Existant', 'You cannot delete this link as it doesn\'t exists in your favorites list!', 'Error displayed when someone tries to delete a link not in their list.', 'TEXTAREA', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Cookie Name', 'gtlsql_fave', 'You can set the name of the cookie used if you wish.', 'TEXT', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'MyLinks_SQL', [ ['Max Per Page', '5', 'Set the number of favorites to display per page. ', 'TEXT', []
, []
, '' ] ] );
    ;
    return "The plugin has been successfully removed!";
}

1;
